/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIModelElementPrivate.idl
 */

#ifndef __gen_nsIModelElementPrivate_h__
#define __gen_nsIModelElementPrivate_h__


#ifndef __gen_nsIXFormsModelElement_h__
#include "nsIXFormsModelElement.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIXFormsControl; /* forward declaration */

class nsISchemaType; /* forward declaration */

class nsIInstanceElementPrivate; /* forward declaration */

class nsIDOMNode; /* forward declaration */


/* starting interface:    nsIModelElementPrivate */
#define NS_IMODELELEMENTPRIVATE_IID_STR "a6522c1a-a343-4b36-a130-75eb279a667a"

#define NS_IMODELELEMENTPRIVATE_IID \
  {0xa6522c1a, 0xa343, 0x4b36, \
    { 0xa1, 0x30, 0x75, 0xeb, 0x27, 0x9a, 0x66, 0x7a }}

/**
 * Private interface implemented by the model element for other
 * elements to use.
 */
class NS_NO_VTABLE nsIModelElementPrivate : public nsIXFormsModelElement {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IMODELELEMENTPRIVATE_IID)

  /**
   * Called by form control elements when they are bound to or unbound from
   * this model.  These form controls will be refreshed when refresh() is
   * called on the model.
   */
  /* void addFormControl (in nsIXFormsControl control); */
  NS_IMETHOD AddFormControl(nsIXFormsControl *control) = 0;

  /* void removeFormControl (in nsIXFormsControl control); */
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control) = 0;

  /**
   * Determine the type for a form control based on the schema included by
   * this model.
   */
  /* nsISchemaType getTypeForControl (in nsIXFormsControl control); */
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval) = 0;

  /** 
   * This function takes an instance data node, finds the type bound to it, and
   * returns the seperated out type and namespace URI.  If no type is set for
   * the node, then it returns the defaults: "http://www.w3.org/2001/XMLSchema"
   * and "string"
   */
  /* void getTypeAndNSFromNode (in nsIDOMNode instancenode, out AString type, out AString namespaceURI); */
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI) = 0;

  /**
   * Notification that an instance element has started or finished loading
   * its instance data.  Model contstruction cannot complete until all of
   * the instances have loaded their data.
   */
  /* void instanceLoadStarted (); */
  NS_IMETHOD InstanceLoadStarted(void) = 0;

  /* void instanceLoadFinished (in boolean success); */
  NS_IMETHOD InstanceLoadFinished(PRBool success) = 0;

  /**
   * Locate the instance element child with the given id.
   */
  /* nsIInstanceElementPrivate findInstanceElement (in AString id); */
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval) = 0;

  /**
   * Set the value of an instance node.
   */
  /* void setNodeValue (in nsIDOMNode contextNode, in AString nodeValue, out boolean nodeChanged); */
  NS_IMETHOD SetNodeValue(nsIDOMNode *contextNode, const nsAString & nodeValue, PRBool *nodeChanged) = 0;

  /**
   * Get the value of an instance node.
   */
  /* void getNodeValue (in nsIDOMNode contextNode, out AString nodeValue); */
  NS_IMETHOD GetNodeValue(nsIDOMNode *contextNode, nsAString & nodeValue) = 0;

  /**
   * Insert a set of nodes underneath an instance node.
   * @param aContextNode       The instance node
   * @param aNodeContent       Node that holds the contents to insert under
   *                           the instance node
   * @param aNodeChanged       Indicates whether the contents of the instance
   *                           node really did change due to this action
   */
  /* void setNodeContent (in nsIDOMNode aContextNode, in nsIDOMNode aNodeContent, out boolean aNodeChanged); */
  NS_IMETHOD SetNodeContent(nsIDOMNode *aContextNode, nsIDOMNode *aNodeContent, PRBool *aNodeChanged) = 0;

  /**
   * Validates the instance node against the schemas loaded by the model.
   */
  /* PRBool validateNode (in nsIDOMNode aInstanceNode); */
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval) = 0;

  enum { SUBMIT_SERIALIZE_NODE = 1U };

  enum { SUBMIT_SKIP_NODE = 2U };

  enum { SUBMIT_ABORT_SUBMISSION = 3U };

  /**
   * Handles an instance data node and returns one of the above 3 values.
   */
  /* unsigned short handleInstanceDataNode (in nsIDOMNode aInstanceDataNode); */
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval) = 0;

  /**
   * Set MIP states for given control bound to the given bound node.
   * @param aControl          The control
   * @param aBoundNode        The node the control is bound to
   */
  /* void setStates (in nsIXFormsControl aControl, in nsIDOMNode aBoundNode); */
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode) = 0;

  /**
   * Add an instance element to the model's instance list
   * @param aInstanceElement        The instance element to add to the list
   */
  /* void addInstanceElement (in nsIInstanceElementPrivate aInstanceElement); */
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement) = 0;

  /**
   * This attribute is set when the model's instance was lazy authored
   */
  /* readonly attribute boolean lazyAuthored; */
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored) = 0;

  /**
    * Retrieves the type for an instance data node
    *
    * @param aInstanceData     The instance data node
    * @param aType             The type of the node
    * @param aNSURI            The namespace of the type
    */
  /* void GetTypeFromNode (in nsIDOMNode aInstanceData, out AString aType, out AString aNSUri); */
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMODELELEMENTPRIVATE \
  NS_IMETHOD AddFormControl(nsIXFormsControl *control); \
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control); \
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval); \
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI); \
  NS_IMETHOD InstanceLoadStarted(void); \
  NS_IMETHOD InstanceLoadFinished(PRBool success); \
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval); \
  NS_IMETHOD SetNodeValue(nsIDOMNode *contextNode, const nsAString & nodeValue, PRBool *nodeChanged); \
  NS_IMETHOD GetNodeValue(nsIDOMNode *contextNode, nsAString & nodeValue); \
  NS_IMETHOD SetNodeContent(nsIDOMNode *aContextNode, nsIDOMNode *aNodeContent, PRBool *aNodeChanged); \
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval); \
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval); \
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode); \
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement); \
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored); \
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMODELELEMENTPRIVATE(_to) \
  NS_IMETHOD AddFormControl(nsIXFormsControl *control) { return _to AddFormControl(control); } \
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control) { return _to RemoveFormControl(control); } \
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval) { return _to GetTypeForControl(control, _retval); } \
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI) { return _to GetTypeAndNSFromNode(instancenode, type, namespaceURI); } \
  NS_IMETHOD InstanceLoadStarted(void) { return _to InstanceLoadStarted(); } \
  NS_IMETHOD InstanceLoadFinished(PRBool success) { return _to InstanceLoadFinished(success); } \
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval) { return _to FindInstanceElement(id, _retval); } \
  NS_IMETHOD SetNodeValue(nsIDOMNode *contextNode, const nsAString & nodeValue, PRBool *nodeChanged) { return _to SetNodeValue(contextNode, nodeValue, nodeChanged); } \
  NS_IMETHOD GetNodeValue(nsIDOMNode *contextNode, nsAString & nodeValue) { return _to GetNodeValue(contextNode, nodeValue); } \
  NS_IMETHOD SetNodeContent(nsIDOMNode *aContextNode, nsIDOMNode *aNodeContent, PRBool *aNodeChanged) { return _to SetNodeContent(aContextNode, aNodeContent, aNodeChanged); } \
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval) { return _to ValidateNode(aInstanceNode, _retval); } \
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval) { return _to HandleInstanceDataNode(aInstanceDataNode, _retval); } \
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode) { return _to SetStates(aControl, aBoundNode); } \
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement) { return _to AddInstanceElement(aInstanceElement); } \
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored) { return _to GetLazyAuthored(aLazyAuthored); } \
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri) { return _to GetTypeFromNode(aInstanceData, aType, aNSUri); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIMODELELEMENTPRIVATE(_to) \
  NS_IMETHOD AddFormControl(nsIXFormsControl *control) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddFormControl(control); } \
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveFormControl(control); } \
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTypeForControl(control, _retval); } \
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTypeAndNSFromNode(instancenode, type, namespaceURI); } \
  NS_IMETHOD InstanceLoadStarted(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->InstanceLoadStarted(); } \
  NS_IMETHOD InstanceLoadFinished(PRBool success) { return !_to ? NS_ERROR_NULL_POINTER : _to->InstanceLoadFinished(success); } \
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->FindInstanceElement(id, _retval); } \
  NS_IMETHOD SetNodeValue(nsIDOMNode *contextNode, const nsAString & nodeValue, PRBool *nodeChanged) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNodeValue(contextNode, nodeValue, nodeChanged); } \
  NS_IMETHOD GetNodeValue(nsIDOMNode *contextNode, nsAString & nodeValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNodeValue(contextNode, nodeValue); } \
  NS_IMETHOD SetNodeContent(nsIDOMNode *aContextNode, nsIDOMNode *aNodeContent, PRBool *aNodeChanged) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNodeContent(aContextNode, aNodeContent, aNodeChanged); } \
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->ValidateNode(aInstanceNode, _retval); } \
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->HandleInstanceDataNode(aInstanceDataNode, _retval); } \
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetStates(aControl, aBoundNode); } \
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddInstanceElement(aInstanceElement); } \
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLazyAuthored(aLazyAuthored); } \
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTypeFromNode(aInstanceData, aType, aNSUri); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsModelElementPrivate : public nsIModelElementPrivate
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMODELELEMENTPRIVATE

  nsModelElementPrivate();

private:
  ~nsModelElementPrivate();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsModelElementPrivate, nsIModelElementPrivate)

nsModelElementPrivate::nsModelElementPrivate()
{
  /* member initializers and constructor code */
}

nsModelElementPrivate::~nsModelElementPrivate()
{
  /* destructor code */
}

/* void addFormControl (in nsIXFormsControl control); */
NS_IMETHODIMP nsModelElementPrivate::AddFormControl(nsIXFormsControl *control)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeFormControl (in nsIXFormsControl control); */
NS_IMETHODIMP nsModelElementPrivate::RemoveFormControl(nsIXFormsControl *control)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsISchemaType getTypeForControl (in nsIXFormsControl control); */
NS_IMETHODIMP nsModelElementPrivate::GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getTypeAndNSFromNode (in nsIDOMNode instancenode, out AString type, out AString namespaceURI); */
NS_IMETHODIMP nsModelElementPrivate::GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void instanceLoadStarted (); */
NS_IMETHODIMP nsModelElementPrivate::InstanceLoadStarted()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void instanceLoadFinished (in boolean success); */
NS_IMETHODIMP nsModelElementPrivate::InstanceLoadFinished(PRBool success)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIInstanceElementPrivate findInstanceElement (in AString id); */
NS_IMETHODIMP nsModelElementPrivate::FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setNodeValue (in nsIDOMNode contextNode, in AString nodeValue, out boolean nodeChanged); */
NS_IMETHODIMP nsModelElementPrivate::SetNodeValue(nsIDOMNode *contextNode, const nsAString & nodeValue, PRBool *nodeChanged)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getNodeValue (in nsIDOMNode contextNode, out AString nodeValue); */
NS_IMETHODIMP nsModelElementPrivate::GetNodeValue(nsIDOMNode *contextNode, nsAString & nodeValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setNodeContent (in nsIDOMNode aContextNode, in nsIDOMNode aNodeContent, out boolean aNodeChanged); */
NS_IMETHODIMP nsModelElementPrivate::SetNodeContent(nsIDOMNode *aContextNode, nsIDOMNode *aNodeContent, PRBool *aNodeChanged)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* PRBool validateNode (in nsIDOMNode aInstanceNode); */
NS_IMETHODIMP nsModelElementPrivate::ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* unsigned short handleInstanceDataNode (in nsIDOMNode aInstanceDataNode); */
NS_IMETHODIMP nsModelElementPrivate::HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setStates (in nsIXFormsControl aControl, in nsIDOMNode aBoundNode); */
NS_IMETHODIMP nsModelElementPrivate::SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addInstanceElement (in nsIInstanceElementPrivate aInstanceElement); */
NS_IMETHODIMP nsModelElementPrivate::AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean lazyAuthored; */
NS_IMETHODIMP nsModelElementPrivate::GetLazyAuthored(PRBool *aLazyAuthored)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void GetTypeFromNode (in nsIDOMNode aInstanceData, out AString aType, out AString aNSUri); */
NS_IMETHODIMP nsModelElementPrivate::GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIModelElementPrivate_h__ */
