/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsControl.idl
 */

#ifndef __gen_nsIXFormsControl_h__
#define __gen_nsIXFormsControl_h__


#ifndef __gen_nsIXFormsContextControl_h__
#include "nsIXFormsContextControl.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMNode; /* forward declaration */

class nsIDOMElement; /* forward declaration */

  #include "nsCOMArray.h"

/* starting interface:    nsIXFormsControl */
#define NS_IXFORMSCONTROL_IID_STR "8377c845-5d55-4eee-9a76-0f86751dcbc8"

#define NS_IXFORMSCONTROL_IID \
  {0x8377c845, 0x5d55, 0x4eee, \
    { 0x9a, 0x76, 0x0f, 0x86, 0x75, 0x1d, 0xcb, 0xc8 }}

/**
 * Interface implemented by all XForms form control classes.
 */
class NS_NO_VTABLE nsIXFormsControl : public nsIXFormsContextControl {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSCONTROL_IID)

  /**
   * Tries to move focus to form control and returns true if succeeded.
   */
  /* boolean tryFocus (); */
  NS_IMETHOD TryFocus(PRBool *_retval) = 0;

  /**
   * The instance node that the control is bound to.
   */
  /* readonly attribute nsIDOMNode boundNode; */
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode) = 0;

  /**
   * The instance nodes that the control depend on.
   *
   * In other words, all the instance nodes that could influence which node
   * the control is bound to (mBoundNode). For example:
   * If a node has @ref="/share[@owner = /me]", it depends on all /share
   * nodes, all @owned attributes on /share nodes, and all /me nodes.
   */
  /* readonly attribute nsCOMArrayPtr dependencies; */
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies) = 0;

  /**
   * Get the element that should receive events for the control.
   *
   * @todo This should not be necessary, we should send directly to the
   * control (XXX)
   */
  /* readonly attribute nsIDOMElement element; */
  NS_IMETHOD GetElement(nsIDOMElement * *aElement) = 0;

  /** According to sec 4.1 in the spec, only certain controls are allowed to
   *  be targets of the interaction and notification events.  The controls
   *  that inherit from nsXFormsControlStub that SHOULDN'T get these events
   *  need to override IsEventTarget() and return PR_FALSE
   */
  /* boolean isEventTarget (); */
  NS_IMETHOD IsEventTarget(PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSCONTROL \
  NS_IMETHOD TryFocus(PRBool *_retval); \
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode); \
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies); \
  NS_IMETHOD GetElement(nsIDOMElement * *aElement); \
  NS_IMETHOD IsEventTarget(PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSCONTROL(_to) \
  NS_IMETHOD TryFocus(PRBool *_retval) { return _to TryFocus(_retval); } \
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode) { return _to GetBoundNode(aBoundNode); } \
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies) { return _to GetDependencies(aDependencies); } \
  NS_IMETHOD GetElement(nsIDOMElement * *aElement) { return _to GetElement(aElement); } \
  NS_IMETHOD IsEventTarget(PRBool *_retval) { return _to IsEventTarget(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSCONTROL(_to) \
  NS_IMETHOD TryFocus(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->TryFocus(_retval); } \
  NS_IMETHOD GetBoundNode(nsIDOMNode * *aBoundNode) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBoundNode(aBoundNode); } \
  NS_IMETHOD GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDependencies(aDependencies); } \
  NS_IMETHOD GetElement(nsIDOMElement * *aElement) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetElement(aElement); } \
  NS_IMETHOD IsEventTarget(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsEventTarget(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsControl : public nsIXFormsControl
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSCONTROL

  nsXFormsControl();

private:
  ~nsXFormsControl();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsControl, nsIXFormsControl)

nsXFormsControl::nsXFormsControl()
{
  /* member initializers and constructor code */
}

nsXFormsControl::~nsXFormsControl()
{
  /* destructor code */
}

/* boolean tryFocus (); */
NS_IMETHODIMP nsXFormsControl::TryFocus(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMNode boundNode; */
NS_IMETHODIMP nsXFormsControl::GetBoundNode(nsIDOMNode * *aBoundNode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsCOMArrayPtr dependencies; */
NS_IMETHODIMP nsXFormsControl::GetDependencies(nsCOMArray<nsIDOMNode> * *aDependencies)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIDOMElement element; */
NS_IMETHODIMP nsXFormsControl::GetElement(nsIDOMElement * *aElement)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isEventTarget (); */
NS_IMETHODIMP nsXFormsControl::IsEventTarget(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsControl_h__ */
